From 349dc7554936b30b4110688509c736b12606eba1 Mon Sep 17 00:00:00 2001
From: Jacob Godserv <jacobgodserv@gmail.com>
Date: Wed, 13 May 2015 21:51:00 -0400
Subject: [PATCH] FL-2373: initial attempt at a plasma5 mix-in

---
 .../funtoo/1.0/linux-gnu/mix-ins/plasma5/README    |  6 +++
 .../1.0/linux-gnu/mix-ins/plasma5/make.defaults    |  5 +++
 .../1.0/linux-gnu/mix-ins/plasma5/package.use      | 50 ++++++++++++++++++++++
 .../funtoo/1.0/linux-gnu/mix-ins/plasma5/use.force |  4 ++
 4 files changed, 65 insertions(+)
 create mode 100644 profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/README
 create mode 100644 profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/make.defaults
 create mode 100644 profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/package.use
 create mode 100644 profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/use.force

diff --git a/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/README b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/README
new file mode 100644
index 0000000..f3df961
--- /dev/null
+++ b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/README
@@ -0,0 +1,6 @@
+This is a direct copy of the gentoo:targets/desktop/plasma profile, with the
+parent file removed. Thanks goes to the Gentoo KDE team for their effort on
+bringing KDE SC 5 to the Gentoo tree!
+
+Because KDE SC 5 is not complete, this is expected to change as KDE SC 5
+and KDE Plasma 5 continue to stabilize.
diff --git a/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/make.defaults b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/make.defaults
new file mode 100644
index 0000000..b15ad80
--- /dev/null
+++ b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/make.defaults
@@ -0,0 +1,5 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/profiles/targets/desktop/plasma/make.defaults,v 1.1 2015/02/01 18:12:35 kensington Exp $
+
+USE="consolekit declarative dri kde kipi phonon plasma policykit qml qt5 semantic-desktop widgets xcomposite xinerama xscreensaver"
diff --git a/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/package.use b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/package.use
new file mode 100644
index 0000000..bdb878d
--- /dev/null
+++ b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/package.use
@@ -0,0 +1,50 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/profiles/targets/desktop/plasma/package.use,v 1.4 2015/05/07 18:09:23 kensington Exp $
+
+# Not required, but makes life easier with Qt; Gentoo bug 457934
+app-arch/unzip natspec
+
+# Required by app-office/akonadi-server
+dev-qt/qtsql mysql
+
+# Required by dev-qt/qtcore
+dev-libs/libpcre pcre16
+
+# Required by media-gfx/graphviz which is required by kde-apps/kcachegrind
+media-libs/gd fontconfig
+
+# Required by kde-apps/libkexiv2
+media-gfx/exiv2 xmp
+
+# Required by kde-base/pykde4
+dev-python/PyQt4 script sql webkit
+
+# Required by kde-frameworks/kactivities
+sys-libs/zlib minizip
+
+# Required by kde-frameworks/kapidox
+media-gfx/graphviz python
+
+# Required by kde-frameworks/kcoreaddons
+dev-qt/qtcore icu
+
+# Required by kde-plasma/kwin
+media-libs/mesa egl
+
+# ### FL-2373 ###
+# kde mixin doesn't allow for minimal USE flag.
+# For now, mixing KDE4 and Plasma 5 isn't supported here.
+# As a result, the following lines are commented out by Funtoo.
+# ###############
+## Allow certain KDE 4 components to be coinstalled with Plasma 5
+#<dev-util/kdevelop-4.8.0 -gdbui
+#kde-base/baloo minimal
+#kde-base/kactivities minimal
+#kde-base/kde-l10n minimal
+#kde-base/kde-meta minimal
+#kde-base/kdeartwork-meta minimal
+#kde-base/kdebase-kioslaves minimal
+#kde-base/kdebase-meta minimal
+#kde-base/kdebase-runtime-meta minimal
+#sys-auth/polkit-kde-agent minimal
diff --git a/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/use.force b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/use.force
new file mode 100644
index 0000000..5a52ef0
--- /dev/null
+++ b/profiles/funtoo/1.0/linux-gnu/mix-ins/plasma5/use.force
@@ -0,0 +1,4 @@
+# Force policykit on, other configurations are *maybe* possible but 
+# not supported. If you know how to disable this mask, you also know enough to 
+# handle the consequences.
+policykit
-- 
2.4.0